#!/usr/bin/perl -w

# This file is part of the Scilab Atoms Compilation Chain
#
# Scilab Atoms Compilation Chain is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Copyright (C) 2009-2010 - DIGITEO - Pierre MARECHAL
# Copyright (C) 2016 - Scilab Enterprises
#

use strict;

use File::Copy;

BEGIN {
# Allow running from anywhere
use FindBin; 
push @INC, "$FindBin::Bin";
}

use AtomsCC::Log;

use AtomsCC::Check;
use AtomsCC::Build;
use AtomsCC::GetInfos;
use AtomsCC::Pack;
use AtomsCC::Publish;
use AtomsCC::SysUtils;
use AtomsCC::Test;
use AtomsCC::Clean;

if (defined($ARGV[0]) && $ARGV[0] eq '--migrate') {
    # One-time functionality created to migrate binary files 
    # from the "test" env (atoms_test DB) to the "stage" env (set in ini/AtomsCC.ini)
    # probably this doesn't need to be kept... just in case

    use LWP::Simple qw(getstore);

    basic_initialization();
    load_ini_file();
    stage_Clean();
    login();

   # The file was generated with:
   # ssh web@atoms.scilab.org "mysql -u atoms_user -pXXXXXX -e 'select t.name, t.version, f.scilab_supported_version, f.file_class, f.name, replace(f.description, CONCAT(CHAR(10 using utf8), \"Automatically generated by the ATOMS compilation chain\", CHAR(10 using utf8)), \"\") description, f.type from files f, Toolbox t where f.when_upload > \"2016-05-24 18:14:49\" and t.id = f.toolbox_id and f.valid = 1 and t.valid = 1 and f.file_class like \"%binary%\";' atoms_test " | tail -n +2 > /Users/francois/scilab/atoms/tb.tab
    my $file = "/Users/francois/scilab/atoms/tb.tab";

    open(my $data, '<', $file) or die "Could not open '$file' $!\n";
 
    while (my $line = <$data>) {
        my @fields = split(/\t/, $line);

        $::toolbox_name = $fields[0];
        $::toolbox_name    =~ s/(^\s*|\s*$)//gs;

        $::toolbox_version = $fields[1];
        $::toolbox_version    =~ s/(^\s*|\s*$)//gs;

        $::scilab_version_short = $fields[2];
        $::scilab_version_short =~ s/(^\s*|\s*$)//gs;

        my $binary_file_class = $fields[3];
        $binary_file_class =~ s/(^\s*|\s*$)//gs;

        my $file_name = $fields[4];
        $file_name =~ s/(^\s*|\s*$)//gs;

        my $binary_description = $fields[5];
        $binary_description =~ s/(^\s*|\s*$)//gs;

        my $binary_type = $fields[6];
        $binary_type =~ s/(^\s*|\s*$)//gs;

        info('Publishing toolbox '.$::toolbox_name.' '.$::toolbox_version);

        $::binary = $::work.$::sep.'binaries'.$::sep.$file_name;
        my $download_url = 'http://test.atoms.scilab.org/toolboxes/'.$::toolbox_name.'/'.$::toolbox_version.'/files/'.$file_name;

        if( getstore($download_url, $::binary) != 200 ) {
            warning("Could not download published file from $download_url");
        }

        $::FORCE_PUBLISH = 0;
        $::HAS_NATIVE_CODE = ($binary_file_class eq 'all binary') ? 0 : 1;

        do_publish($binary_description, $binary_file_class, $binary_type);
    }

    exit(0);
}


$::DEFAULT_SCILAB_VERSION = '5.5.2';
$::DEFAULT_SCILAB_PATH = '';

# Options
# ==============================================================================
$::HELP            = 0;
$::PUBLISH         = 0;
$::FORCE_PUBLISH   = 0;
$::SKIPBUILD       = 0;
$::SKIPTESTS       = 0;
$::KEEPSOURCES     = 0;
$::HAS_NATIVE_CODE = 0;
$::VERBOSE         = 0;
$::NOTIMEOUT       = 0;

for( my $i=0 ; $i<=$#ARGV ; $i++)
{
    my $this_arg = $ARGV[$i];
    $this_arg    =~ s/(^\s*|\s*$)//gs;

    if( ( $this_arg eq '--help' ) || ($this_arg eq '-h' ) )
    {
        $::HELP = 1;
    }
    elsif( ( $this_arg eq '--verbose' ) || ($this_arg eq '-v' ) )
    {
        $::VERBOSE = 1;
    }
    elsif( ( $this_arg eq '--notimeout' ) || ($this_arg eq '-n' ) )
    {
        $::NOTIMEOUT = 1;
    }
    elsif( ( $this_arg eq '--sources' ) || ($this_arg eq '-s' ) )
    {
        if(defined($ARGV[$i+1])){
            $::LOCALSOURCES = $ARGV[$i+1];
            $::LOCALSOURCES =~ s/(^\s*|\s*$)//gs;
            $::LOCALSOURCES = File::Spec->rel2abs($::LOCALSOURCES);

            if( ! -e $::LOCALSOURCES ) {
                error("Specified source file or folder \'$::LOCALSOURCES\' does not exist");
            }

            if ( -d $::LOCALSOURCES ) {
                verbose("Building from source directory $::LOCALSOURCES");
            }
            else {
                verbose("Building from source file $::LOCALSOURCES");
            }
        }
        else{
            error("No source file specified");
        }
        $i++;
    }
    elsif( ( $this_arg eq '--publish' ) || ( $this_arg eq '-p' ) )
    {
        $::PUBLISH = 1;
        verbose("Will publish the binaries on the Atoms website");
    }
    elsif( ( $this_arg eq '--force' ) || ( $this_arg eq '-f' ) )
    {
        $::FORCE_PUBLISH = 1;
        $::PUBLISH = 1;
        verbose("Will publish the binaries on the Atoms website, even if already present");
    }
    elsif( ( $this_arg eq '--login' ) || ( $this_arg eq '-l' ) )
    {
        if(defined($ARGV[$i+1])){
            $::atoms_login = $ARGV[$i+1];
            $::atoms_login =~ s/(^\s*|\s*$)//gs;
        }
        else {
            error("No login to Atoms specified");
        }
    }
    elsif( ( $this_arg eq '--password' ) || ( $this_arg eq '-w' ) )
    {
        if(defined($ARGV[$i+1])){
            $::atoms_password = $ARGV[$i+1];
            $::atoms_password =~ s/(^\s*|\s*$)//gs;
        }
        else {
            error("No password to Atoms specified");
        }
    }
    elsif( ( $this_arg eq '--skipbuild' ) || ( $this_arg eq '-b' ) )
    {
        $::SKIPBUILD = 1;
        verbose("Skipping build");
    }
    elsif( ( $this_arg eq '--skiptests' ) || ( $this_arg eq '-t' ) )
    {
        $::SKIPTESTS = 1;
        verbose("Skipping testing");
    }
    elsif( ( $this_arg eq '--keepsources' ) || ( $this_arg eq '-k' ) )
    {
        $::KEEPSOURCES = 1;
        info("Keeping the sources in the produced output");
    }
    elsif( ( $this_arg eq '--scilab-version' ) || ( $this_arg eq '-u' ) )
    {
        if(defined($ARGV[$i+1])){
            my $scilabversion = $ARGV[$i+1];
            $scilabversion =~ s/(^\s*|\s*$)//gs;

            $::scilab_version = $scilabversion;

            if ( ! ($scilabversion =~ /^\d+\.\d+/) ) {
                error("Incorrect format for Scilab version '$scilabversion', must be x.y[.z[alpha-t|beta-t]]");
            }
        }
        else{
            error("Please specify a Scilab version to build against.");
        }

        $i++;
    }
    elsif( ( $this_arg eq '--scilab-path' ) || ( $this_arg eq '-P' ) )
    {
        if(defined($ARGV[$i+1])){
            my $scilabpath = $ARGV[$i+1];
            $scilabpath =~ s/(^\s*|\s*$)//gs;

            $::scilab_path = $scilabpath;
        }
        else{
            error("Please specify path after --scilab-path (or -P) option to look for your scilab install.");
        }
        $i++;
    }
    elsif( $this_arg =~ m/^-/ )
    {
        error("Unrecognized option: $this_arg. Use --help for a list of valid options");
    }
    else
    {
        $::toolbox_name    = $this_arg;
        if(defined($ARGV[$i+1]) && $ARGV[$i+1] =~ m/^([0-9]+\.[0-9]+)+/i){
            $::toolbox_version = $ARGV[$i+1]; # Version of the toolbox
            $::toolbox_version =~ s/(^\s*|\s*$)//gs;
            $i++;
        }
    }
}

basic_initialization();

# Display the help
# ==============================================================================

if($::HELP)
{
    print 'Usage: perl build.pl [OPTIONS] TOOLBOX_NAME [TOOLBOX_VERSION]'."\n";
    print '   Download the sources of toolbox TOOLBOX_NAME from the Atoms website,'."\n";
    print '   build it, run the tests, and optionally publish the binary back to Atoms.'."\n";
    print '   The latest version is built unless TOOLBOX_VERSION (in format \'x.y[.z]\') is specified.'."\n";
    print "\n";
    print "OPTIONS can be:\n";
    print '  --help (-h)                    Display this help and exit'."\n";
    print '  --keepsources (-k)             Keep the source files in the generated binaries'."\n";
    print '  --skiptests (-t)               Do not run the tests of the toolbox'."\n";
    print '  --skipbuild (-b)               Do not run the build: reuse previously built binary to run the test (and/or publish).'."\n";
    print '  --scilab-version (-u) VERSION  Build using Scilab version VERSION instead of \''.$::DEFAULT_SCILAB_VERSION."\'\n";
    print '  --scilab-path (-P) PATH        Searches for Scilab version in PATH instead of \''.$::DEFAULT_SCILAB_PATH."\'\n";
    print '  --sources (-s) PATH            Use sources (zip or folder) from local path PATH instead of downloading them'."\n";
    print '  --publish (-p)                 Publish the binary build to the Atoms website (requires login and password)'."\n";
    print '  --force (-f)                   Force publishing the binary build to the Atoms website, even if it was already published.'."\n";
    print '  --login (-l)                   Atoms server login. Overrides value found in ini/AtomcCC.ini'."\n";
    print '  --password (-w)                Atoms server password. Overrides value found in ini/AtomcCC.ini'."\n";
    print '  --notimeout (-n)               Never timeout when running Scilab (may hang if build or tests hang)'."\n";
    print '  --verbose (-v)                 Show more information during build'."\n";

    exit(1);
}


if (!defined($::scilab_version)) {
    $::scilab_version = $::DEFAULT_SCILAB_VERSION;
    verbose('Building against Scilab default version '.$::scilab_version);
}


($::scilab_version_short) = $::scilab_version =~ m/^(\d+\.\d+)/;

verbose("<major>.<minor> Scilab version is: $::scilab_version_short");

if(!defined($::toolbox_name)) {
    error('No toolbox name specified, cannot build. Run --help for usage');
}

if(defined($::toolbox_version) && defined($::LOCALSOURCES)) {
    error("cannot have both --sources and a version specified");
}

load_ini_file();

find_scilab();

if( $::PUBLISH ) {
    login();
}

if(defined($::toolbox_version)){
    info('Building toolbox '.$::toolbox_name.' '.$::toolbox_version);
}else{
    info('Building toolbox '.$::toolbox_name.' (latest version)');
}

#
# Now do the build
#
if ( ! $::SKIPBUILD ) {
    stage_Clean();
}

my $sources;
if (defined($::LOCALSOURCES)) {
    $sources = stage_Unpack($::LOCALSOURCES);

    # we will use the DESCRIPTION from the server if it exists...
    my $description = stage_downloadDESCRIPTION();
    # ... but also check that the local DESCRIPTION is correct (if it exists)
    if ( -e $sources.$::sep."DESCRIPTION" ) {
        stage_parseDESCRIPTION($sources.$::sep."DESCRIPTION");

        if ( ! ($::toolbox{'name'} eq $::toolbox_name)) {
            error("Toolbox name in DESCRIPTION file (in ".$::LOCALSOURCES.") does not match name provided on command line");
        }
    }
    else {
        if (! $description ) {
            error("No DESCRIPTION in local sources, and unable to get it from server: cannot build");
        } else {
            warning("No DESCRIPTION file found in local sources. Using the one for the server");
        }
    }

    if ($description) {
        stage_parseDESCRIPTION($description);

        # always use DESCRIPTION from server if it exists
        verbose("Copying DESCRIPTION found on server instead to sources");
        copy($description, $sources.$::sep."DESCRIPTION");
    }
}
else {
    my $description = stage_downloadDESCRIPTION();
    if (! $description) {
        error("Cannot build without DESCRIPTION");
    }
    stage_parseDESCRIPTION($description);
    my $downloaded = stage_Download();
    $sources = stage_Unpack($downloaded);
    copy($description, $sources.$::sep."DESCRIPTION");
}

if(!defined($::toolbox_version)) {
    $::toolbox_version = $::toolbox{'version'};
    info('Latest version of the toolbox is: '.$::toolbox_version);
}

if (index($::scilab_version, $::source{'supportedscilab'}) != 0)
{
    warning("Building against Scilab version ".$::scilab_version." but source was created with ".$::source{'supportedscilab'}.": build may not work; extra care at testing needed");
}

my $compilation_path = $::work.$::sep.'compil'.$::sep.$::toolbox_name.'_'.$::toolbox_version;

if ( ! $::SKIPBUILD ) {
    copyDir($sources, $compilation_path);

    # Check the sources
    stage_Check($compilation_path);

    # Do the Build
    stage_Build($compilation_path);
}

if ( -e $sources.$::sep.'sci_gateway' or -e $sources.$::sep.'src' ) {
    if ( !($::toolbox{'hasnativecode'} eq 'Yes') ) {
        error("Toolbox definition on ATOMS says it does not contain native code, but native code found in toolbox. Please check and fix toolbox definition on ATOMS.");
    }
    $::HAS_NATIVE_CODE = 1;
}
else {
    if ($::toolbox{'hasnativecode'} eq 'Yes') {
        warning("Toolbox definition on ATOMS says it needs a specific build for each platform, but only macros found in toolbox:");
        if ( $::PUBLISH ) {
            warning("the toolbox will be published for all platforms; if you want to publish it only for some platforms,");
            warning("you will need to do that on the ATOMS website (and hide the file published here).");
        }
        else {
            warning("Publishing it using AtomsCC will publish for all platforms;");
            warning("To publish it only for some platforms, you should publish it manually using the ATOMS website.");
        }            
    }
    else {
        info('The toolbox only contains macros: packaging only once for all platforms');
    }
}

stage_SetBinaryName();

if ( ! $::SKIPBUILD ) {
    # Clean the toolbox
    stage_CleanForBinary($compilation_path);
    # Package the toolbox
    stage_Pack($compilation_path);
}
else {
    if ( ! -e $::binary ) {
        error("Binary file '$::binary' not found. Please re-run build, or verify that the build has not been uploaded already.");
    }
}
# Test the toolbox
if( ! $::SKIPTESTS ) {
    # 0 = don't raise warnings - can happen if has run already
    stage_CleanScilab(0);

    stage_Test();

    stage_CleanScilab(1);
}

# Publish the built package
if ( $::PUBLISH )
{
    stage_Publish();
}

if( $::HAS_NATIVE_CODE ) {
    warning('This toolbox has platform-specific code: you must publish it on each supported platform: win32, win64, linux32, linux64 and macosx.');
}

if (had_warnings()) {
    warning('Build succeeded, but there were some warnings. Please check them carefully');
}
else {
    info('Build finished successfully');
}
